package org.geekfu.Cartographer;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;

public class ColorCell extends MapCell{
    private Color background,foreground; // The colors to use for this cell
    private boolean drawdot; // Whether to draw just the background, or the FG as a dot.
    
    /**
     * @param revealed
     * @param background
     * @param drawdot
     * @param foreground
     */
    public ColorCell(Color background, Color foreground,boolean drawdot) {
        super();
        // TODO Auto-generated constructor stub
        this.background = background;
        this.drawdot = drawdot;
        this.foreground = foreground;
    }
    
    public ColorCell() {
        background=Color.GRAY;
        foreground=Color.GRAY;
        drawdot=false;
    }
    
    /**
     * @param background
     * @param foreground
     */
    public ColorCell(Color background, Color foreground) {
        super();
        // TODO Auto-generated constructor stub
        this.background = background;
        this.foreground = foreground;
    }

    @Override
    public void repaint() {
        Rectangle d=new Rectangle(getSize());
        Graphics2D g=getCanvas().createGraphics();
        if(background!=null){
	        g.setColor(background);
	        g.fillRect(0,0,d.width,d.height);
        }
        if(drawdot && foreground!=null)
        {
        	g.setColor(foreground);
        	g.fillOval(d.width/4,d.width/4,d.width/2,d.height/2);
        }
    }

    public Color getBackground() {
        return background;
    }

    public boolean isDrawdot() {
        return drawdot;
    }

    public Color getForeground() {
        return foreground;
    }

    public void setBackground(Color background) {
        this.background = background;
    }

    public void setDrawdot(boolean drawdot) {
        this.drawdot = drawdot;
    }

    public void setForeground(Color foreground) {
        this.foreground = foreground;
    }
}
