package org.geekfu.Cartographer;

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.Serializable;

public class MapCell implements Serializable, Cloneable{
	public static final int TYPE=BufferedImage.TYPE_INT_ARGB;
    public Object clone() {try {
    		MapCell other=(MapCell) super.clone();
    		if(size!=null)
    			other.size=new Dimension(size);
    		if(constraints!=null)
    			other.constraints=new MapLayoutConstraints(constraints);
    		if(canvas!=null)
    		{
    			other.canvas=new BufferedImage(canvas.getWidth(),canvas.getHeight(),TYPE);
    			other.canvas.getGraphics().drawImage(canvas,0,0,null);
    		}
        return other;
    } catch (CloneNotSupportedException exc) {
        exc.printStackTrace();
        return null;
    }}

    private Dimension size; // How large the current visualization is
    protected MapLayoutConstraints constraints; // Where it is in the map, iff it's a piece
    protected BufferedImage canvas; // Whatever you draw to this is displayed on the map
    protected Map map;
    
    public MapLayoutConstraints getConstraints() {
		return constraints;
	}

	public void setConstraints(MapLayoutConstraints constraints) {
		this.constraints = constraints;
	}

	/**
     * @param revealed
     */
    public MapCell() {
    		super();
    }
    
    public BufferedImage getCanvas(){return canvas;}
    public void repaint(){}
    
    public void mouseEntered(int b) {}
    public void mouseClicked(int b) {}
    public void mouseMoved(int b) {}
    public void mouseExited(int b) {}
    public void mouseDragged(int b) {}
    public void mousePressed(int b) {}
    public void mouseReleased(int b) {}
    
    public Dimension getSize() {
        return size;
    }

    public void setSize(Dimension size) {
        this.size = size;
        canvas=new BufferedImage(size.width,size.height,TYPE);
        repaint();
    }

	public Map getMap() {
		return map;
	}

	public void setMap(Map map) {
		this.map = map;
	}

	public void setCanvas(BufferedImage canvas) {
		this.canvas=new BufferedImage(canvas.getWidth(),canvas.getHeight(),TYPE);
		this.canvas.getGraphics().drawImage(canvas,0,0,null);
	}
}
