/**
 * 
 */
package org.geekfu.Cartographer;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;

public class MapLayoutConstraints implements Comparable{
  public MapPoint point;
  public MapPoint offset;

public MapLayoutConstraints() {
      point=new MapPoint(0,0);
      offset=new MapPoint(0,0);
  }

  public MapLayoutConstraints(MapLayoutConstraints other){
	this(other.point,other.offset);  
  }
  
  public MapLayoutConstraints(MapPoint point) {
      this.point=point;
      offset=new MapPoint(0,0);
  }

  public MapLayoutConstraints(Point point) {
      this.point=new MapPoint(point.x,point.y);
      offset=new MapPoint(0,0);
  }

  public MapLayoutConstraints(MapPoint point,MapPoint offset) {
      this.point=(MapPoint) point.clone();
      this.offset=(MapPoint) offset.clone();
  }

  public MapLayoutConstraints(MapPoint point,int xOffset,int yOffset) {
      this.point=point;
      offset=new MapPoint(xOffset,yOffset);
  }

  public MapLayoutConstraints(int x,int y,int xOffset,int yOffset) {
      point=new MapPoint(x,y);
      offset=new MapPoint(xOffset,yOffset);
  }

  public MapLayoutConstraints(int x,int y) {
      this(x,y,0,0);
  }
  
  public void translate(int x,int y) {
      offset.x+=x;offset.y+=y;
  }
  
  public int compareTo(Object obj) {
      if(obj instanceof MapLayoutConstraints)
      {
          MapLayoutConstraints other=((MapLayoutConstraints)obj);
          int pointcomp=point.compareTo(other.point);
          if(pointcomp!=0)return pointcomp;
          else return offset.compareTo(other.offset);
      }
      else throw new ClassCastException();
  }

  public boolean equals(Object other) {
      if(!(other instanceof MapLayoutConstraints))return false;
      MapLayoutConstraints cons=(MapLayoutConstraints) other;
      return point.equals(cons.point) && offset.equals(cons.offset);
  }

public MapPoint getOffset() {
    return offset;
}

public MapPoint getPoint() {
    return point;
}

public void setOffset(MapPoint offset) {
    this.offset = offset;
}

public void setPoint(MapPoint point) {
    this.point = point;
}

public Rectangle getBounds(Dimension cellsize) {
	int xCoord=point.x*cellsize.width+offset.x;
	int yCoord=point.y*cellsize.height+offset.y;
	return new Rectangle(xCoord,yCoord,cellsize.width,cellsize.height);
}
}